\documentclass{article}
\usepackage[utf8]{inputenc}

\usepackage{amsmath,amssymb,amsthm,textcomp}
\usepackage{enumerate}
\usepackage{multicol}
\usepackage{tikz}
\usepackage{mathpartir}

\begin{document}

\section*{1. Syntaxe Abstraite}
\begin{mathpar}
  \inferrule*[Left=L: empty]
    { }
    {\epsilon \in L}
\and
  \inferrule[Left=L: cons]
    {n \in \mathbb{N},\; m \in M}
    {cons(n,m) \in L}
\end{mathpar}

\begin{mathpar}
  \inferrule*[Left=O: count]
    {m \in M}
    {count(m) \in O}

  \inferrule*[Left=O: sum]
    {m \in M}
    {sum(m) \in O}
\end{mathpar}

\begin{mathpar}
  \inferrule*[Left=M: add]
    {n \in \mathbb{N},\; m \in M}
    {add(n,m) \in M}


  \inferrule*[Left=M: concat]
    {m_1 \in M\; m_2 \in M}
    {concat(m_1,m_2) \in M}

  \inferrule*[Left=M: L]
    {l \in L}
    {l \in M}
\end{mathpar}

\begin{mathpar}
  \inferrule*[Left=P: M]
    {m \in M}
    {m \in P}

  \inferrule*[Left=P: O]
    {o \in O}
    {o \in P}
\end{mathpar}


\section*{2. Domaine Sémantique}
$P$

\section*{3. Opérateur d'évaluation}
$\Rightarrow_P :  P \to L \cup \mathbb{N}$ \\
$\Rightarrow_M : M \to L$ \\
$\Rightarrow_O : O \to \mathbb{N}$ \\
$\Rightarrow_L :  M \to L$ \\

\section*{4. Sémantique de Liste}
$n \in \mathbb{N},\;p \in P,\;m_k \in M,\;l_k \in L$
\begin{mathpar}
  \inferrule*[Left=L Empty :]{ }{\epsilon \Rightarrow_L \epsilon}
\\
  \inferrule*[Left=Cons :]
    {m \Rightarrow_M l}
    {cons(n,m) \Rightarrow_L cons(n,l)}
\\
  \inferrule*[Left=Count Base:]
    {m \Rightarrow_M \epsilon}
    {count(m) \Rightarrow_O 0}




  \inferrule*[Left=Count Recursif:]
    {m \Rightarrow_M cons(n,m')}
    {count(m) \Rightarrow_O count(m') + 1}
\\
  \inferrule*[Left=Sum Base:]
    {m \Rightarrow_M \epsilon}
    {sum(m) \Rightarrow_O 0}



  \inferrule*[Left=Sum Recursif:]
    {m \Rightarrow_M cons(n,m')}
    {sum(m) \Rightarrow_O sum(m') + n}
  
\\
  \inferrule*[Left=Add Base:]
    {m \Rightarrow_M \epsilon}
    {add(n,m) \Rightarrow_M cons(n,\epsilon)}



  \inferrule*[Left=Add Recursif:]
    {m \Rightarrow_M l}
    {add(n,m) \Rightarrow_M cons(n,l)}
\\
  \inferrule*[Left=Concat Base:]
    {m_\epsilon \Rightarrow_L \epsilon, m' \Rightarrow_L l'}
    {concat(m_\epsilon,m') \Rightarrow_M l'}
\\
  \inferrule*[Left=Concat Recursif:]
    {m_1 \Rightarrow_L cons(n,m'_1),\; m_2 \Rightarrow_L l_2,\; concat(m'_1, l_2) \Rightarrow_M m_\Omega}
    {concat(m_1,m_2) \Rightarrow_M cons(n, m_\Omega)}
\\
  \inferrule*[Left=M: L]{m \in L,\; m \Rightarrow_L l}{m \Rightarrow_M l}
\\
  \inferrule*[Left=P: M]{p \in M,\; p \Rightarrow_M l}{p \Rightarrow_P l}
  
  \inferrule*[Left=P: O]{p \in O,\; p \Rightarrow_O n}{p \Rightarrow_P n}
\end{mathpar}

\end{document}

